#ifndef PLAN_H
#define PLAN_H


#include<iostream>
#include<vector>

using namespace std;

#include "dp.h"

class State;

class Plan{
	bool infinity;				//**Note, don't re-write this member directly;
	unsigned total_cost;
public:
	vector<unsigned> seq;
	State es;
	
	Plan();
	Plan(const Plan& p);	
	~Plan();
	unsigned cost();
	unsigned evaluate_cost();
	
	Plan& operator=(const Plan& p);	
	void add_oper(unsigned op);
	void copy(Plan& dest);
	bool merge(Plan& to_be_merged);	
	void clone(const Plan& p);
	void set_infinity();
	void set_empty();
	bool is_empty();
	bool is_infinity();
	
	unsigned& operator[](unsigned offset);	
	unsigned length();
	void print();
	void println();
	void println(const char* str);
	void print_well_formated();
	void write_to_file(const char* filename);	

	static Plan& 	create_infinity_plan();
	static Plan& 	create_empty_plan();
	bool 			check_consistency(const char* str);
};

#endif 
