#ifndef SEARCH_CONTEXT_H
#define SEARCH_CONTEXT_H

#include <set>

#include "dp.h"
#include "transition_graph.h"

using namespace std;

const unsigned MAX_FIXED_LIST_LEN = 300;
const bool FULL_PERMUTATIONS  = true;

class Fringe;
class CloseList;

class SearchContext{
public:
		unsigned 	depth;
			bool 	recurMark[MAX_DTG_NUM];	
		unsigned 	fixed_fact[MAX_FIXED_LIST_LEN];
		unsigned 	num_fixed_fact;
		unsigned    print_level;
			bool	debug;
		 Fringe*	fringe_ptr;
		 	bool	do_permutation;
		 	
	set<unsigned> cg_index;
	CloseList& close_list;
	SearchContext(CloseList& list);
	~SearchContext();
	bool isDebug();
	void print_ff_list();
	bool info(const char *str);
	
	/* 		Inline functions;  */
	
	inline void add_ff( unsigned fact ){
		fixed_fact[num_fixed_fact++] = fact;
		assert( num_fixed_fact < MAX_FIXED_LIST_LEN);
	}
	inline void add_ff(TransitionVertex& vertex){
		unsigned i;
		for(i=0;i<vertex.dimension;i++)
			add_ff( vertex[i] );
	}
	inline bool is_violating_ff(TransitionVertex& vertex){
		unsigned i;
		for(i=0;i<vertex.dimension;i++)
			if( is_violating_ff( vertex[i]) )
				return true;
		return false;
	}
	inline bool is_violating_ff(unsigned fact){
		unsigned i;
		for(i=0;i<num_fixed_fact;i++)
			if( fixed_fact[i] == fact )
				return true;
		return false;
	}

	//SSDB						//to-do:SSDB
};


#endif 
