#ifndef SOLVER_CONTEXT_H
#define SOLVER_CONTEXT_H


#include "dp.h"

class Plan;

class SolverContext{
public:
	char domain_file[MAX_FILENAME];
	char prob_file[MAX_FILENAME];
	char soln_file[MAX_FILENAME];
	char path[MAX_FILENAME];
  	
	float 	global_mlimit;
	float 	max_mcspn;	
	unsigned  global_tlimit;
  	
	bool	dgo;
	bool 	debug;
	unsigned display_info;
	unsigned search_print_level;
	unsigned search_strategy;
	unsigned fixed_scope;
	
	SolverContext();
	bool process_command_line(int argc, char *argv[]);
	
	bool check_tlimit();
	bool check_mlimit();
	void update_memory_usage();

};


#endif 
