#ifndef STATE_H
#define STATE_H


#include<iostream>
#include<string>
#include<vector>

#include "dp.h"
//#include "task.h"

using namespace std;

class Operator;
class Task;

class State{
	unsigned pool_pos;			//Address of the memory space in the pre-allocated pool
public:
	unsigned* gvalue;
	
	State();
	State(vector<unsigned>& init);
	//State(unsigned facts, unsigned size);		//to-do: is it useless??????
	State(const State& s);
	~State();
	void   clone(const State& p);	//Deep copy
	State& operator=(const State& p);	
	unsigned& operator[](unsigned offset);
	
	bool 	check_goal(vector<unsigned>& goals);
	bool   	is_valid();
	bool	isSatisfied(unsigned* array, unsigned size);	
	//bool 	apply_action_effect(Operator& oper);
	bool 	apply_action_effect(unsigned oper);	
	void 	translate_from_strips(vector<unsigned>& init);	
	void 	print();
	void 	println(const char* str);
	unsigned hash_value();	
	
	inline bool isValid(){
		if( this->gvalue!=NULL ) return true;
		else return false;
	}	
};

#endif 
