/**********************************
 * R. Huang, Y. Chen and W. Zhang
 * Washington University in STL
 * MAY/2008
 *********************************/

#include<iostream>


#include "dp.h"
#include "state.h"
#include "plan.h"
#include "transition_graph.h"
#include "solver_context.h"
#include "utils.h"
#include "resource_allocator.h"
#include "task.h"

using namespace std;

//Make it global!!! and the last one to be freed!!
ResourceAllocator& ra = ResourceAllocator::getInstance();

int main(int argc, char *argv[]){
	
	SolverContext context;
	context.process_command_line(argc, argv);
	
	Task& task = Task::getInstance();
	task.solverContext = &context;
	task.initialize_everything();
	task.build_sas_formulation(); 
	task.analysis();
	
	Plan plan = task.solve();
		
	if( !plan.is_infinity() ){
		//plan.write_to_file( context.soln_file );
	}else
		cout<<"Failed to solve the instance."<<endl;
	
	printf("\n");
	printf("nrAction:	\t%d\n",plan.length());
	printf("Time:		\t%f sec\n", get_global_time() );
	printf("\n");

	return 0;
}

//END OF FILE;

