/**********************************
 * R. Huang, Y. Chen and W. Zhang
 * Washington University in STL
 * MAY/2008
 *********************************/



#include<iostream>
#include<stdio.h>

#include "state.h"
#include "plan.h"
#include "task.h"
#include "fringe.h"
#include "solver_context.h"
#include "search_context.h"

using namespace std;

static Task&task = Task::getInstance();


SearchContext::SearchContext(CloseList& list):close_list(list){
	depth 	= 0;  
	num_fixed_fact 	= 0;
	print_level = task.solverContext->search_print_level;
	debug = task.solverContext->debug;
	memset( recurMark, false, sizeof(bool) * MAX_DTG_NUM );
	fringe_ptr = NULL;
	do_permutation = true;
} 

SearchContext::~SearchContext(){

	
}


void SearchContext::print_ff_list(){
	unsigned i;
	printf("FIXED facts:");
	for(i=0;i<num_fixed_fact;i++)
		task.gft[fixed_fact[i]].print_name();
	printf("\n");
}



bool SearchContext::isDebug(){
	return ( depth< print_level );
	return false;
}



bool SearchContext::info(const char *str){
	if( depth < this->print_level )
		printf("[%d]%s",depth,str);
	
	return isDebug();
}











