#include<dp.h>
#include<transition_graph.h>
#include<solver_context.h>
#include<task.h>
#include<plan.h>
#include<iostream>
#include<stdio.h>

using namespace std;

int main(int argc, char *argv[]){
	cout<<"!!In test Task Parsing"<<endl;
	
	SolverContext* context = new SolverContext();
	strncpy(context->domain_file,"domain.pddl",MAX_STR_LEN);
	strncpy(context->prob_file,"p01.pddl",MAX_STR_LEN);
	context->process_command_line(argc, argv);

	Task& task = Task::getInstance();
	task.solverContext = context;
	task.initialize();
	
	cout<<"Testing task parsing Done."<<endl;

	task.print();
	
	int i,j;
	printf("Printing all the actions[%d]\n",task.gnum_op);
	for(i=0;i<task.objects.size();i++)
		cout<<task.objects[i].name<<endl;
	
	cout<<"There are facts of num "<<task.gnum_ft<<endl;
	for(i=0;i<task.gnum_ft;i++)
		cout<<task.gft[i].name<<";";
	cout<<endl;
	
	cout<<"DTG Groups"<<endl;
	for(i=0;i<task.graphGroup.size();i++){
		for(j=0;j<task.graphGroup[i].size();j++){
			cout<<task.graphGroup[i][j]<<" ";
		}
		cout<<endl;
	}
	
	cout<<"Mutex Groups"<<endl;
	for(i=0;i<task.mutexGroup.size();i++){
		for(j=0;j<task.mutexGroup[i].size();j++){
			cout<<task.mutexGroup[i][j]<<" ";
		}
		cout<<endl;
	}
	
	for(i=0;i<task.gnum_op;i++){
		task.gop[i].print_int();
	}
	

	/*
	printf("orderings:\n");
	for(i=0;i<task.gnum_ft;i++)
	for(j=0;j<task.gnum_ft;j++)
		if( task.forced_ordering[i][j] ){
			task.print_ft_name(i); printf("   "); 
			task.print_ft_name(j); printf("\n");
		}
	printf("\nAgenda%d\n",task.goals_agenda.size());
	for(i=0;i<task.goals_agenda.size();i++){
		printf("%d\n",task.goals_agenda[i].size());
		for(j=0;j<task.goals_agenda[i].size();j++)
			task.print_ft_name( task.goals_agenda[i][j] );///,printf("%d,\n",goal_order[goal_agenda[i].F[j]]);
	}
	*/
	
	
	cout<<endl<<"To build transitionGraphs"<<endl;
	//task.initialize();
	/**   **/
	task.build_sas_formulation();
	
	/*
	cout<<"building transition graph finished."<<endl;
	for(int i=0;i<task.transGraphNum;i++){
		cout<<"printing transGraph"<<i<<endl;
		task.transGraph[i].print();
	} */
	
	
	cout<<"SAS formated actions"<<endl;
	for(i=0;i<task.gnum_op;i++){
		if( !task.gop[i].isDisabled ) 
			task.gop[i].print_as_sas();
	}
	printf("TEST TASK DONE.\n");
}
